--Sprite Savekeys
--version 0.7 for 3DStudioMax R4
--by Michael Brempel
--directory:...\ui\macroscripts\
------------------------------------------------------------------
--known bugs(todo+ideen):xyz einbauen; einleseroutine
------------------------------------------------------------------
macroScript Savekeys
category:"MAX Script Tools"
--internalcategory:"MAX Script Tools"
tooltip:"Savekeys"
Icon:#("maintoolbar",85)
SilentErrors:(Debug == undefined or Debug != True)
(
---------------------------------------------------------Funktionen
fn getsubtree obj =
(
	append harray obj
	for ch in obj.children do
	(
		getsubtree ch
	)
)


fn rename obj=	--<root-obj>
(
	local cname=0
	for ch in obj.children do
	(
		cname=cname+1
		name=obj.name+"_"+(cname as string)
		ch.name=name
		rename ch
	)
)
-------------------------------------------------------------------GLOBALES+CONTROLLERWERTE
global objectsarray=#()
global _infoarray=#()
global c_array=#()
global _key=""
--untersttzte controller
av_rotcontrollers=#("TCB_Rotation","Euler_XYZ","Linear_Rotation","Smooth_Rotation")
av_poscontrollers=#("TCB_Position","Position_XYZ","Linear_Position","Bezier_Position")
av_scalecontrollers=#("TCB_Scale","ScaleXYZ","Linear_Scale","Bezier_Scale")

--rotation
c_TCB_Rotation=#("value","tension","continuity","bias","easeto","easefrom")
--c_Euler_XYZ=#("")->sonderfall
c_linear_rotation=#("value")
c_bezier_rotation=#("value")

--position
c_tcb_position=#("value","tension","continuity","bias","easeto","easefrom")
--c_Position_XYZ=#("")->sonderfall
c_linear_position=#("value")
c_bezier_position=#("value","intangenttype","outtangenttype","intangent","outtangent")

--scale
c_tcb_scale=#("value","tension","continuity","bias","easeto","easefrom")
--c_ScaleXYZ=#("")->sonderfall
c_linear_scale=#("value")
c_Bezier_Scale=#("value","intangenttype","outtangenttype","intangent","outtangent")

-------------------------------------------------------------------
r_floater=newrolloutfloater "Savekeys" 190 203
-------------------------------------------------------------------
rollout r_info "Info"
(
	group "Important"
	(
		label l2 "-Select the objects whose" align:#left
		label l3 " keys should be saved." align:#left
		label l4 "-The objects for the saved" align:#left
		label l5 " and the loaded keys have" align:#left
		label l6 " to have the same names." align:#left
		label l7 "-Operates with TCB, Bezier" align:#left
		label l8 " and Linear-controllers." align:#left
		label l9 "-Other controllers will be" align:#left
		label l10" converted to Bezier/TCB." align:#left
		label l11"-You should delete all keys" align:#left
		label l12" except the first key in a" align:#left
		label l13" track before import keys." align:#left
		label l14"Tip: Use Setkey at frame 0" align:#left
		--label l15"Best Usability with Bezier" align:#left
		--label l16"and TCB-controller." align:#left
		label l17"-Autorename renames a hierar-" align:#left
		label l18" chy by its path...root=1;" align:#left
		label l19" children are 1_1, 1_2, etc" align:#left
		label l20"-Select only the root by" align:#left
		label l21" renaming." align:#left
		label l22"-No undo by renaming!!!" align:#left
	)
	group "About"
	(
		label l_1 " Savekeys v0.7/R4" align:#left
		label l_2 " October 2002" align:#left
		label l_3 " by Michael Brempel" align:#left
		label l_4 " mbrempel@gmx.de" align:#left
	)
)
-------------------------------------------------------------------
rollout r_rename "Rename hierarchy"
(
	button b_savelist "save hierarchy-list" width:128 height:17
	button b_getlist "get hierarchy-list" width:128 height:17
	button b_autorename "autorename" width:128 height:17


	on b_getlist pressed do
	(
		bug=0
		_openpath=getopenfilename filename:"*.txt" types:"HierarchyList(*.txt)|*.txt|All|*.*"
		if _openpath!=undefined then
		(
			if selection.count==1 then
 			(
				_datastream=openfile _openpath
				in selection[1]
 				(
 					objarray=$* as array	
 				)

				for obj in objarray do
				(
					if eof _datastream then
					(
						messagebox "There are more objects in the hierarchy than names in the file!" title:"Abort"
						bug=1
						exit
					)
					obj.name=readline _datastream
				)
				close _datastream
				if bug==0 then
					messagebox "Ok."
			)
			else
				messagebox "Please select one object(the root)." title:"HierarchyList"
		)
	)

	on b_savelist pressed do
	(
		_savepath=getsavefilename filename:"*.txt" types:"HierarchyList(*.txt)|*.txt|All|*.*"
 		if _savepath!=undefined then
 		(
 			if selection.count==1 then
 			(
 				_datastream=createfile _savepath
 				in selection[1]
 				(
 					objarray=$* as array	
 				)
				for obj in objarray do
				(
					format (obj.name+"\n") to:_datastream
				)
				close _datastream
				messagebox "Ok."
			)
			else
				messagebox "Please select one object(the root)." title:"HierarchyList"
		)
	)

	on b_autorename pressed do
	(
		if selection.count==1 then
		(
			selection[1].name="1"
			rename selection[1]
			messagebox "Ok."
		)
		else
			messagebox "Please select only one object(the root)." title:"Autorename"
	)
)
-------------------------------------------------------------------

rollout r_setkey "Savekeys"
(
	group "SetKey"
	(
		button b_last "last" width:65 height:17 align:#left across:2
		button b_interpolate "interpolate" width:65 height:17 align:#right
	)
	group "In/Out"
	(
		button b_export "keyexport" width:65 height:17 align:#left across:2
		button b_import "keyimport" width:65 height:17 align:#right
	)

	on b_last pressed do
	(
		undo "Savekeys_last" on
		(
			For i = 1 to selection.count do
			(
				createlockkey Selection[i].pos.controller SliderTime 1
				createlockkey Selection[i].rotation.controller SliderTime 1
				createlockkey Selection[i].scale.controller SliderTime 1
			)
		)
	)

	on b_interpolate pressed do
	(
		undo "Savekeys_interpolate" on
		(
			For i = 1 to selection.count do
			(
				addnewkey Selection[i].pos.controller SliderTime --#interpolate
				addnewkey Selection[i].rotation.controller SliderTime --#interpolate
				addnewkey Selection[i].scale.controller SliderTime --#interpolate
			)
		)
	)
----------------------------------------------------------------------------------------export
	on b_export pressed do
	(
		_savepath=getsavefilename filename:"*.ky2"\
		types:"Keys(*.ky2)|*.ky2|All|*.*"
		if _savepath!=undefined then
		(
			_abort=0
			_datastream=createfile _savepath
			objectsarray=getCurrentSelection()
			For i = 1 to objectsarray.count do
			(
				
				_undo=0
				undo "Savekeys_reset" on
				(
					--CONTROLLER AVAILABLE? -> ELSE CONVERT
					if (findItem av_rotcontrollers (substring (objectsarray[i].rotation.controller as string) 12 25))==0 then
					(
						print (substring (objectsarray[i].rotation.controller as string) 12 25)
						print "convert_rotation"
						objectsarray[i].rotation.controller = tcb_rotation ()
						_undo=1
					)
					if (findItem av_poscontrollers (substring (objectsarray[i].pos.controller as string) 12 25))==0 then
					(
						
						print (substring (objectsarray[i].pos.controller as string) 12 25)
						print "convert_position"
						objectsarray[i].pos.controller = bezier_position ()
						_undo=1
					)
					if (findItem av_scalecontrollers (substring (objectsarray[i].scale.controller as string) 12 25))==0 then
					(
						
						print (substring (objectsarray[i].scale.controller as string) 12 25)
						print "convert_scale"
						objectsarray[i].scale.controller = bezier_scale ()
						_undo=1
					)
				)
				
				--ROTATIONKEYS
				if objectsarray[i].rotation.controller.keys.count!=0 then
				(
					--format ("--\n") to:_datastream
					if (objectsarray[i].rotation.controller as string)=="Euler_XYZ" then	--xyz als sonderfall
					(
						messagebox "xyz not impelemented yet."
						exit
					)
					else
					(
						case (substring (objectsarray[i].rotation.controller as string) 12 25) of	--definierte arrays holen
						(
							"TCB_Rotation":c_array=c_TCB_Rotation
							"Linear_Rotation":c_array=c_linear_rotation
							"Smooth_Rotation":c_array=c_bezier_rotation
							default:(
									messagebox "error in arrayzuweisung(rot)" title:"abort"
									_abort=1
									exit
								)
						)
						_keys=objectsarray[i].rotation.controller.keys
						for _time=1 to _keys.count do
						(
							c_string=(substring (objectsarray[i].rotation.controller as string) 12 25)
							c_string=c_string+"|rot"+"|"+(objectsarray[i].rotation.controller.keys[_time].time as string)+"|$"+(objectsarray[i].name)
							for i1=1 to c_array.count do
							(
								--print ("objectsarray["+i as string+"].rotation.controller.keys["+_time  as string+"]."+c_array[i1]+" as string")
								c_string2=execute("objectsarray["+i as string+"].rotation.controller.keys["+_time  as string+"]."+c_array[i1]+" as string")
								c_string=c_string+"|"+c_string2
							)
							format (c_string+"\n") to:_datastream
							_time+=1
						)
					)
				)
				
				--POSITIONKEYS
				if objectsarray[i].pos.controller.keys.count!=0 then
				(
					--format ("--\n") to:_datastream
					if (objectsarray[i].pos.controller as string)=="Position_XYZ" then	--xyz als sonderfall
					(
						messagebox "xyz not impelemnted yet."
						exit
					)
					else
					(
						case (substring (objectsarray[i].pos.controller as string) 12 25) of	--definierte arrays holen
						(
							"TCB_Position":c_array=c_tcb_position
							"Linear_Position":c_array=c_linear_position
							"Bezier_Position":c_array=c_bezier_position
							default:(
									messagebox "error in arrayzuweisung(pos)" title:"abort"
									_abort=1
									exit
								)
						)
						_keys=objectsarray[i].pos.controller.keys
						for _time=1 to _keys.count do
						(
							c_string=(substring (objectsarray[i].pos.controller as string) 12 25)
							c_string=c_string+"|pos"+"|"+(objectsarray[i].pos.controller.keys[_time].time as string)+"|$"+(objectsarray[i].name)
							for i1=1 to c_array.count do
							(
								--print ("objectsarray["+i as string+"].pos.controller.keys["+_time  as string+"]."+c_array[i1]+" as string")
								c_string2=execute("objectsarray["+i as string+"].pos.controller.keys["+_time  as string+"]."+c_array[i1]+" as string")
								if (c_array[i1]=="intangenttype") or (c_array[i1]=="outtangenttype") then c_string2="#"+c_string2
								c_string=c_string+"|"+c_string2
							)
							format (c_string+"\n") to:_datastream
							_time+=1
						)
					)
				)
				
				--SCALEKEYS
				if objectsarray[i].scale.controller.keys.count!=0 then
				(
					--format ("--\n") to:_datastream
					if (objectsarray[i].scale.controller as string)=="Scale_XYZ" then	--xyz als sonderfall
					(
						messagebox "xyz not impelemnted yet."
					)
					else
					(
						case (substring (objectsarray[i].scale.controller as string) 12 25) of	--definierte arrays holen
						(
							"TCB_Scale":c_array=c_tcb_scale
							"Linear_Scale":c_array=c_linear_scale
							"Bezier_Scale":c_array=c_Bezier_Scale
							default:(
									messagebox "error in arrayzuweisung(scale)" title:"abort"
									_abort=1
									exit
								)
						)
						_keys=objectsarray[i].scale.controller.keys
						for _time=1 to _keys.count do
						(
							c_string=(substring (objectsarray[i].scale.controller as string) 12 25)
							c_string=c_string+"|scale"+"|"+(objectsarray[i].scale.controller.keys[_time].time as string)+"|$"+(objectsarray[i].name)
							for i1=1 to c_array.count do
							(
								--print ("objectsarray["+i as string+"].scale.controller.keys["+_time  as string+"]."+c_array[i1]+" as string")
								c_string2=execute("objectsarray["+i as string+"].scale.controller.keys["+_time  as string+"]."+c_array[i1]+" as string")
								if c_array[i1]=="intangenttype" or c_array[i1]=="outtangenttype" then c_string2="#"+c_string2
								c_string=c_string+"|"+c_string2
							)
							format (c_string+"\n") to:_datastream
							_time+=1
						)
					)
				)
				
				if _undo==1 then max undo
			)
			close _datastream
			objectsarray=undefined
			gc()
			if _abort==0 then messagebox "Keys successfully exported" title:"Savekeys"
		)
	)
-------------------------------------------------------------------------------------import
	on b_import pressed do
	(
		_difference=0
		_errorarray=#()
		_oldobj=""
		_oldcontr=""
		_abort=0	--0=right; 1=error(not aborted); 2=aborted
		
		_openpath=getopenfilename filename:"*.ky2"\
		types:"Keys(*.ky2)|*.ky2|All|*.*"
		if _openpath!=undefined then
		(
			_datastream=openfile _openpath
			while eof _datastream==false do
			(
				_keyinfo=readline _datastream
				_infoarray=(filterstring _keyinfo "|")
				if _oldobj!=(_infoarray[4] as string) then
				(
					_object=execute(_infoarray[4])
				)
				_time=execute(_infoarray[3])
				if _object==undefined then
				(
					if (findItem _errorarray (_infoarray[4]))==0 then	--wenn objekt(name) nicht vorhanden
					(
						_click=querybox ("Objekt "+_infoarray[4]+" nicht gefunden!\nVorgang abbrechen?") title:"Error" beep:true
						if _click==true then
						(
							_abort=2
							exit
						)
						else
						(
							_abort=1
							append _errorarray (_infoarray[4])
							_oldobj=(_infoarray[4] as string)
							_oldcontr=""
							continue
						)
					)
					else continue
				)
			-----------------------------------------------------------------------------rotation
				if _infoarray[2]=="rot" then
				(
					if _infoarray[1]=="Euler_XYZ" then	--SONDERFALL
					(
					)
					else
					(
						if (_oldcontr!=_infoarray[2])or(_oldobj!=_infoarray[4] as string) then	--wenn neues objekt
						(
							if _infoarray[1]=="TCB_Rotation" then	--definierte arrays holen
							(
								c_array=c_TCB_Rotation
								if (substring (_object.rotation.controller as string) 12 25)!="TCB_Rotation" then
									_object.rotation.controller=tcb_rotation ()
							)
							else if _infoarray[1]=="Linear_Rotation" then
							(
								c_array=c_linear_rotation
								if (substring (_object.rotation.controller as string) 12 25)!="Linear_Rotation" then
									_object.rotation.controller=linear_rotation ()
							)
							else if _infoarray[1]=="Smooth_Rotation" then
							(
								c_array=c_bezier_rotation
								if (substring (_object.rotation.controller as string) 12 25)!="Smooth_Rotation" then
									_object.rotation.controller=bezier_rotation ()
							)
							else
							(
								messagebox "error in arrayzuweisung(rot)" title:"abort"
								_abort=1
								exit
							)
							_key=addnewkey _object.rotation.controller _time
							_oldobj=(_infoarray[4] as string)
							_oldcontr=_infoarray[2]
						)
						else
						(
							_key=addnewkey _object.rotation.controller _time
							_key.value=execute(_infoarray[5])
						)
						i2=2
						for i=6 to _infoarray.count do
						(
							--print ("_key."+c_array[i2]+"="+_infoarray[i])
							execute ("_key."+c_array[i2]+"="+_infoarray[i])
							i2+=1
						)
					)
				)
			-----------------------------------------------------------------------------position
				else if _infoarray[2]=="pos" then
				(
					if _infoarray[1]=="Position_XYZ" then	--SONDERFALL
					(
					)
					else
					(
						if (_oldcontr!=_infoarray[2])or(_oldobj!=_infoarray[4] as string) then	--wenn neues objekt
						(
							if _infoarray[1]=="TCB_Position" then	--definierte arrays holen
							(
								c_array=c_tcb_position
								if (substring (_object.pos.controller as string) 12 25)!="TCB_Position" then
									_object.pos.controller=tcb_position ()
							)
							else if _infoarray[1]=="Linear_Position" then
							(
								c_array=c_linear_position
								if (substring (_object.pos.controller as string) 12 25)!="Linear_Position" then
									_object.pos.controller=linear_position ()
							)
							else if _infoarray[1]=="Bezier_Position" then
							(
								c_array=c_bezier_position
								if (substring (_object.pos.controller as string) 12 25)!="Bezier_Position" then
									_object.pos.controller=bezier_position ()
							)
							else
							(
								messagebox "error in arrayzuweisung(pos)" title:"abort"
								_abort=1
								exit
							)
							_key=addnewkey _object.pos.controller _time
							_oldobj=(_infoarray[4] as string)
							_oldcontr=_infoarray[2]
							_difference=_key.value-(execute(_infoarray[5]))
						)
						else
						(
							_key=addnewkey _object.pos.controller _time
							_key.value=(execute(_infoarray[5]))+_difference
						)
						i2=2
						for i=6 to _infoarray.count do
						(
							--print ("_key."+c_array[i2]+"="+_infoarray[i])
							execute ("_key."+c_array[i2]+"="+_infoarray[i])
							i2+=1
						)
					)
				)
			-----------------------------------------------------------------------------scale
				else if _infoarray[2]=="scale" then
				(
					if _infoarray[1]=="ScaleXYZ" then	--SONDERFALL
					(
					)
					else
					(
						if (_oldcontr!=_infoarray[2])or(_oldobj!=_infoarray[4] as string) then	--wenn neues objekt
						(
							if _infoarray[1]=="TCB_Scale" then	--definierte arrays holen
							(
								c_array=c_tcb_position
								if (substring (_object.scale.controller as string) 12 25)!="TCB_Scale" then
									_object.scale.controller=tcb_scale ()
							)
							else if _infoarray[1]=="Linear_Scale" then
							(
								c_array=c_linear_position
								if (substring (_object.scale.controller as string) 12 25)!="Linear_Scale" then
									_object.scale.controller=linear_scale ()
							)
							else if _infoarray[1]=="Bezier_Scale" then
							(
								c_array=c_bezier_position
								if (substring (_object.scale.controller as string) 12 25)!="Bezier_Scale" then
									_object.scale.controller=bezier_scale ()
							)
							else
							(
								messagebox "error in arrayzuweisung(scale)" title:"abort"
								_abort=1
								exit
							)
							_key=addnewkey _object.scale.controller _time
							_oldobj=(_infoarray[4] as string)
							_oldcontr=_infoarray[2]
							_difference=_key.value-(execute(_infoarray[5]))
						)
						else
						(
							_key=addnewkey _object.scale.controller _time
							_key.value=(execute(_infoarray[5]))+_difference
						)
						i2=2
						for i=6 to _infoarray.count do
						(
							--print ("_key."+c_array[i2]+"="+_infoarray[i])
							execute ("_key."+c_array[i2]+"="+_infoarray[i])
							i2+=1
						)
					)
				)
			-----------------------------------------------------------------------------
				else
				(
					messagebox "No position, rotation or scale controller found in the keyfile/line" title:"Error"
					exit
				)
			)--end of while-loop
			close _datastream
			 _infoarray=undefined
			 c_array=undefined
			 _key=undefined
			 gc()
	----------------------------------------------------------------FEHLERAUSGABE
			if _abort==0 then messagebox "Keys successfully imported" title:"Savekeys"
			else if _abort==1 then
			(
				_errorstring=""
				for i=1 to _errorarray.count do
				(
					_errorstring=_errorstring+_errorarray[i]+"; "
					print _errorstring
					if ((i/5==1)or(i/5==2)) then _errorstring=_errorstring+"\n"
					else if (i/5>2.9) then
					(
						_errorstring=_errorstring+"..."
						exit
					)
				)
				messagebox ("Keys imported...but some objects could not be found in the scene.\nPerhaps different names in scene/keyfile?\n\n"+_errorstring+" ") title:"Savekeys"
			)
	----------------------------------------------------------------
		)
	)--end of b_import-pressed
-------------------------------------------------------------------------------------
)--end of rollout
addRollout r_setkey r_floater
addrollout r_rename r_floater rolledUp:true
addrollout r_info r_floater rolledUp:true
)
